<?php
/************************************************************************/
/* NPDS : Net Portal Dynamic System                                     */
/* ===========================                                          */
/*                                                                      */
/* Original Copyright (c) 2001 by Francisco Burzi (fburzi@ncc.org.ve)   */
/* http://phpnuke.org                                                   */
/*                                                                      */
/* This version name NPDS Copyright (c) 2001-2002 by Philippe Brunier   */
/************************************************************************/
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/
/* Un grand merci  GAWAX pour son aide dans le contenu de ce fichier   */
/************************************************************************/

include("config.php");
include("language/lang-$language.php");
include('cache.class.php');

// P.BR For more detailled connection methods ($mysql_p=true => persistente connexion)
function Mysql_Connexion() {
   global $mysql_p, $dbhost, $dbuname, $dbpass, $dbname;

   if (($mysql_p) or (!isset($mysql_p))) {
      $ret_p=mysql_pconnect($dbhost, $dbuname, $dbpass);
   } else {
      $ret_p=mysql_connect($dbhost, $dbuname, $dbpass);
   }

   $mes ="<html><body bgcolor=white><br><center><b><font face=arial color=Red size=3>";
   $mes.="Unable to select DataBase / Impossible d'accder  la Base de Donnes";
   $mes.="<br><br><font size=1 color=black>NPDS - Portal System / Gnrateur de portail";
   $mes.="</font></b></body></html>";

   if ($ret_p!=False) {
      if (!mysql_select_db("$dbname")) {
         // P.BR Retry if is the first connection and MySql Deamon not yet in memory
         if (!mysql_select_db("$dbname")) {
            echo $mes;
            die();
         }
      }
   } else {
      echo $mes;
      die();
   }
}
/****************/
Mysql_Connexion();
$mainfile = 1;
require_once("auth.inc.php");
/****************/

// Une fonction complte pour obtenir l'IP ... Un grand Merci  Snipe pour cette fonction
function getip() {
   if (isSet($_SERVER)) {
      if (isSet($_SERVER["HTTP_X_FORWARDED_FOR"])) {
         $realip = $_SERVER["HTTP_X_FORWARDED_FOR"];
      } elseif (isSet($_SERVER["HTTP_CLIENT_IP"])) {
         $realip = $_SERVER["HTTP_CLIENT_IP"];
      } else {
         $realip = $_SERVER["REMOTE_ADDR"];
      }
   } else {
      if ( getenv( 'HTTP_X_FORWARDED_FOR' ) ) {
         $realip = getenv( 'HTTP_X_FORWARDED_FOR' );
      } elseif ( getenv( 'HTTP_CLIENT_IP' ) ) {
         $realip = getenv( 'HTTP_CLIENT_IP' );
      } else {
         $realip = getenv( 'REMOTE_ADDR' );
      }
   }
   return ($realip);
}

// Une fonction simple pour obtenir cette info ... Un grand Merci  P.PECHARD pour cette fonction
function NightDay() {
   $Maintenant = strtotime ("now");
   $Lever = "08:00";
   $Coucher = "20:00";

   $Jour = strtotime($Lever);
   $Nuit = strtotime($Coucher);
   if ($Maintenant-$Jour<0 xor $Maintenant-$Nuit>0) return "Nuit"; else return "Jour";
}

// P.BR : a usefull function to replace some bad words in a string
// Preg_replace by Pascalp
function removeHack($Xstring) {
   $npds_forbidden_words=array(
   "'from:'i"=>"!from:!",
   "'subject:'i"=>"!subject:!",
   "'bcc:'i"=>"!bcc:!",
   "'content-type:'i"=>"!content-type:!",
   "'content-transfer-encoding:'i"=>"!content-transfer-encoding:!",
   "'content-disposition:'i"=>"!content-disposition:!",
   "'include'i"=>"!include!",
   "'<script'i"=>"&lt;script",
   "'</script'i"=>"&lt;/script",
   "'javascript'i"=>"!javascript!",
   "'embed'i"=>"!embed!",
   "'iframe'i"=>"!iframe!",
   "'refresh'i"=>"!refresh!",
   "'onload'i"=>"!onload!",
   "'onstart'i"=>"!onstart!",
   "'document\.cookie'i"=>"!document.cookie!",
   "'jscript'i"=>"!jscript!",
   "'vbscript'i"=>"!vbscript!",
   "'pearlscript'i"=>"!pearlscript!",
   "'\<\?php'i"=>"&lt;?php",
   "'\<\?'i"=>"&lt;?",
   "'\?\>'i"=>"?&gt;",
   "'\<\%'i"=>"&lt;%",
   "'\%\>'i"=>"%&gt;");

   $Xstring=preg_replace(array_keys($npds_forbidden_words),array_values($npds_forbidden_words), $Xstring);
   return($Xstring);
}

// P.BR : simple microtime function (for perfs analyse for example)
function getmicrotime() {
   list($usec, $sec) = explode(" ",microtime());
   return (float)$usec + (float)$sec;
}

// P.BR : function to send mail
function send_email($email, $subject, $message, $from="", $priority=false, $mime=false) {
   global $mail_fonction, $adminmail;
   $advance="";
   if ($priority) {
      $advance="X-Priority: 1\n";
   }
   if ($mime=="text") {
      $advance.="Content-Type: text/plain; charset=iso-8859-1\n";
   }
   if ($mime=="html") {
      $advance.="Content-Type: text/html; charset=iso-8859-1\n";
   }

   if (($mail_fonction==1) or ($mail_fonction=="")) {
      $From_email=$adminmail;
      if ($from!="") { $From_email=$from; }
      $result=mail($email, $subject, $message, "From: $From_email\nX-Mailer: NPDS\n$advance");
   } else {
      $pos = strpos($adminmail, "@");
      $tomail=substr($adminmail,0,$pos);
      $result=email($tomail, $email, $subject, $message, $tomail, "Return-Path:\nX-Mailer: NPDS\n$advance");
   }

   if ($result) {
      return (true);
   } else {
      return (false);
   }
}

// P.BR copy a specific subject+message to an email (for IM for exemple)
function copy_to_email($to_userid,$sujet,$message) {
       $result = mysql_query("select email,send_email from users where uid='$to_userid'");
       list($mail,$avertir_mail) = mysql_fetch_row($result);
       if (($mail) and ($avertir_mail==1)) {
          send_email($mail,$sujet,$message, "", true, "html");
       }
}

// P.BR : a Meta function to write in a simple log File for security reason
function Ecr_Log($fic_log, $req_log, $mot_log) {
   // $Fic_log= the file name :
   //  => "security" for security maters
   //  => ""
   // $req_log= a phrase describe the infos
   //
   // $mot_log= if "" the Ip is recorded, else extend status infos
   $logfile = "logs/$fic_log.log";
   $fp = fopen($logfile, 'a');
   flock($fp, 2);
   fseek($fp, filesize($logfile));
   if ($mot_log=="") {$mot_log="IP=>".getip();}
   $ibid = sprintf("%-10s %-60s %-10s\r\n",date("m/d/Y H:i:s",time()),basename($GLOBALS[PHP_SELF])."=>".$req_log,$mot_log);
   fwrite($fp, $ibid);
   flock($fp, 3);
   fclose($fp);
}

// P.BR : a useful function to redirect url without header("Location ...") and when header is allways SEND ...
function redirect_url($urlx) {
   echo "<script language=JavaScript>";
   echo "document.location.href='".$urlx."';";
   echo "</script>";
}

// Include cache manager Message
function SC_infos() {
   global $SuperCache, $npds_sc, $textcolor1, $textcolor2;

   $infos="";
   if ($SuperCache) {
      if ($npds_sc) {
         $infos="<font size=1 color=$textcolor1>".translate(".:Page << Super-Cache:.")."</font>";
      } else {
         $infos="<font size=1 color=$textcolor2>".translate(".:Page >> Super-Cache:.")."</font>";
      }
   }
   return $infos;
}

function req_stat() {
   // Les membres
   $result = mysql_query("select uid from users");
   if ($result) {$xtab[0]=mysql_num_rows($result);} else {$xtab[0]="0";}
   // Les Nouvelles (News)
   $result = mysql_query("select sid from stories");
   if ($result) {$xtab[1]=mysql_num_rows($result);} else {$xtab[1]="0";}
   // Les Critiques (Reviews))
   $result = mysql_query("select id from reviews");
   if ($result) {$xtab[2]=mysql_num_rows($result);} else {$xtab[2]="0";}
   // Les Forums
   $result = mysql_query("select forum_id from forums");
   if ($result) {$xtab[3]=mysql_num_rows($result);} else {$xtab[3]="0";}
   // Les Sujets (topics)
   $result = mysql_query("select topicid from topics");
   if ($result) {$xtab[4]=mysql_num_rows($result);} else {$xtab[4]="0";}
   // Nombre de pages vues
   $result = mysql_query("SELECT count FROM counter");
   if ($result) {list($totalz)=mysql_fetch_row($result);}
   $totalz++;
   $xtab[5]=$totalz++;
   mysql_free_result($result);
   return($xtab);
}

// P.BR Bloc activit du site
function Site_Activ() {
   global $startdate, $top;
   list($membres,$totala,$totalb,$totalc,$totald,$totalz)=req_stat();
   $who_online = "<font size=1><center>Pages vues depuis <br>$startdate : <b>$totalz</b></center></font><hr width=80%>
   <li><font size=1>Nb de membres : <b>$membres</b></font></li>
   <li><font size=1>Nb d'articles : <b>$totala</b></font></li>
   <li><font size=1>Nb de forums : <b>$totalc</b></font></li>
   <li><font size=1>Nb de sujets : <b>$totald</b></font></li>
   <li><font size=1>Nb de critiques : <b>$totalb</b></font></li>
   <hr width=90%><center><font size=1><a href=top.php>Top $top</a><br><a href=stats.php>Statistiques</a></font></center></font>";
   $title = translate("Web Activity");
   $content = "$who_online";
   themesidebox($title, $content);
}

// P.BR : Affiche le groupe check_mail (theme principal de NPDS)
function Mess_Check_Mail($username) {
   global $anonymous;
   if ($username == $anonymous) {
      echo "&nbsp;&nbsp;[$username - <a href=\"user.php\">Votre compte</a>]";
   } else {
      echo "&nbsp;&nbsp;[<a href=\"user.php\">Votre compte</a>&nbsp;&middot;&nbsp;".Mess_Check_Mail_Sub($username,"")."]";
   }
}
// P.BR : Affiche le groupe check_mail (theme principal de NPDS)
function Mess_Check_Mail_Sub($username, $class) {
   global $user;
   if ($username) {
      $username = base64_decode($user);
      $userdata = explode(":", $username);
      $total_messages = mysql_num_rows(mysql_query("SELECT msg_id FROM priv_msgs WHERE to_userid = '$userdata[0]' and type_msg='0'"));
      $new_messages = mysql_num_rows(mysql_query("SELECT msg_id FROM priv_msgs WHERE to_userid = '$userdata[0]' AND read_msg='0' and type_msg='0'"));
      if ($total_messages > 0) {
         if ($new_messages > 0) {
            $Xcheck_Nmail=$new_messages;
         } else {
            $Xcheck_Nmail="0";
         }
         $Xcheck_mail=$total_messages;
      } else {
         $Xcheck_Nmail="0";
         $Xcheck_mail="0";
      }
   }

   $YNmail="$Xcheck_Nmail";
   $Ymail="$Xcheck_mail";
   $Mel="<a href=\"viewpmsg.php\" $class>Mel</a>";
   if ($Xcheck_Nmail >0) {
      $YNmail="<a href=\"viewpmsg.php\" $class>$Xcheck_Nmail</a>";
      $Mel="Mel";
   }
   if ($Xcheck_mail >0) {
      $Ymail="<a href=\"viewpmsg.php\" $class>$Xcheck_mail</a>";
      $Mel="Mel";
   }
   return ("$Mel : $YNmail / $Ymail");
}

// P.BR - Theme : qui est en ligne ? + message de bienvenue
function Who_Online() {
   global $user, $textcolor1;

   list($content1, $content2)=Who_Online_Sub();
   $content1 = "<font color=$textcolor1 size=1>$content1</font>";
   $content2 = "<font color=$textcolor1 size=1>$content2</font>";
   return array($content1, $content2);
}
function Who_Online_Sub() {
   global $user, $cookie;

   cookiedecode($user);
   $ip = getip();
   $username = $cookie[1];
   if (!isset($username)) {
      $username = "$ip";
      $guest = 1;
   }
   $past = time()-300;
   mysql_query("DELETE FROM session WHERE time < $past");
   $result = mysql_query("SELECT time FROM session WHERE username='$username'");
   $ctime = time();
   if ($row = mysql_fetch_array($result)) {
      mysql_query("UPDATE session SET username='$username', time='$ctime', host_addr='$ip', guest='$guest' WHERE username='$username'");
   } else {
      mysql_query("INSERT INTO session (username, time, host_addr, guest) VALUES ('$username', '$ctime', '$ip', '$guest')");
   }
   $result = mysql_query("SELECT username FROM session where guest=1");
   $guest_online_num = mysql_num_rows($result);
   $result = mysql_query("SELECT username FROM session where guest=0");
   $member_online_num = mysql_num_rows($result);
   $who_online_num = $guest_online_num + $member_online_num;

   $content1 = "$guest_online_num ".translate("guest(s) and")." $member_online_num ".translate("member(s) that are online.");
   if ($user) {
      $content2 = translate("You are logged as")." <b>$username</b>";
   } else {
      $content2 = translate("You can register for free by clicking")." <a href=user.php?op=only_newuser>".translate("here")."</a>";
   }
   return array($content1, $content2);
}

function online() {
   global $user, $cookie;
   cookiedecode($user);
   $ip = getip();
   $username = $cookie[1];
   if (!isset($username)) {
      $username = "$ip";
      $guest = 1;
   }
   $past = time()-300;
   mysql_query("DELETE FROM session WHERE time < $past");
   $result = mysql_query("SELECT time FROM session WHERE username='$username'");
   $ctime = time();
   if ($row = mysql_fetch_array($result)) {
      mysql_query("UPDATE session SET username='$username', time='$ctime', host_addr='$ip', guest='$guest' WHERE username='$username'");
   } else {
      mysql_query("INSERT INTO session (username, time, host_addr, guest) VALUES ('$username', '$ctime', '$ip', '$guest')");
   }

   $result = mysql_query("SELECT username FROM session where guest=1");
   $guest_online_num = mysql_num_rows($result);
   $result = mysql_query("SELECT username FROM session where guest=0");
   $member_online_num = mysql_num_rows($result);
   $who_online_num = $guest_online_num + $member_online_num;
   $who_online = "<CENTER>".translate("There are currently,")." $guest_online_num ".translate("guest(s) and")." $member_online_num ".translate("member(s) that are online.")."<br>";
   $title = "".translate("Who's Online")."";
   $content = "$who_online";
   if ($user) {
      $content .= "<br>".translate("You are logged as")." <b>$username</b>.<br>";
      $result = mysql_query("select uid from users where uname='$username'");
      list($uid) = mysql_fetch_row($result);
      $result2 = mysql_query("select to_userid from priv_msgs where to_userid='$uid' and type_msg='0'");
      $numrow = mysql_num_rows($result2);
      $content .= "".translate("You have")." <a href=\"viewpmsg.php\"><b>$numrow</b></a> ".translate("private message(s).")."";
   } else {
      $content .= "<br>".translate("You are Anonymous user. You can register for free by clicking <a href=user.php>here</a>.")."</center>";
   }
   themesidebox($title, $content);
}

// P.BR if AutoRegUser=true and user not the right to open session : RAZ the NPDS Cookies
// return False if open session is prohibited / True else
function AutoReg() {
   global $AutoRegUser, $user;
   if (!$AutoRegUser) {
      if (isset($user)) {
         $user2 = base64_decode($user);
         $cookie = explode(":", $user2);
         list($test) = mysql_fetch_row(mysql_query("select open from users_status where uid='$cookie[0]'"));
         if (!$test) {
            setcookie("user","",0);
            return false;
         } else {
            return true;
         }
      } else {
         return true;
      }
   } else {
      return true;
   }
}

// P.BR : a useful function to know who is online, member, admin or advance member. use in static.php and banners.php
function secur_static($sec_type) {
   global $user, $admin;

   switch ($sec_type) {
      case "member":
           if (isset($user)) {
              return true;
           } else {
              return false;
           }
           break;

      case "admin":
           if (isset($admin)) {
              return true;
           } else {
              return false;
           }
           break;

      case "adv_m":
           if (isset($user)) {
              $username = base64_decode($user);
              $userdata = explode(":", $username);
              $result = mysql_query("SELECT uid, name FROM users WHERE uname='$userdata[1]'");
              $userinfo = mysql_fetch_array($result);
              $result = mysql_query("SELECT nom_rs FROM users_advance WHERE uid='$userinfo[uid]'");
              $useradvanceinfo = mysql_fetch_array($result);
              if ($useradvanceinfo[0]!="") {
                 return true;
              } else {
                 return false;
              }
           } else {
              return false;
           }
           break;
   }
}

function OpenTable() {
   global $bgcolor1, $bgcolor2;
   echo "<table width=\"100%\" border=0 cellspacing=1 cellpadding=0 bgcolor=\"$bgcolor2\"><tr><td>\n";
   echo "<table width=\"100%\" border=0 cellspacing=1 cellpadding=8 bgcolor=\"$bgcolor1\"><tr><td>\n";
}

function OpenTable2() {
   global $bgcolor1, $bgcolor2;
   echo "<center>";
   echo "<table border=0 cellspacing=1 cellpadding=0 bgcolor=\"$bgcolor2\"><tr><td>\n";
   echo "<table border=0 cellspacing=1 cellpadding=8 bgcolor=\"$bgcolor1\"><tr><td>\n";
}

function CloseTable() {
   echo "</td></tr></table></td></tr></table>\n";
}

function ultramode() {
   global $nuke_url;
   if (file_exists("ultramode.txt")) {unlink("ultramode.txt");}
   $ultra = "cache/ultramode.txt";
   $netTOzone = "cache/net2zone.txt";
   $file = fopen("$ultra", "w");
   $file2 = fopen("$netTOzone", "w");
   fwrite($file, "General purpose self-explanatory file with news headlines\n");
   $storynum=10;
   $xtab=news_aff("index","",$storynum,"");
   $story_limit=0;
   while (($story_limit<$storynum) and ($story_limit<sizeof($xtab))) {
      list($sid, $catid, $aid, $title, $time, $hometext, $bodytext, $comments, $counter, $topic, $informant, $notes) = $xtab[$story_limit];
      $story_limit++;
      $rfile2=mysql_query("select topictext, topicimage from topics where topicid=$topic");
      list($topictext, $topicimage) = mysql_fetch_row($rfile2);
      fwrite($file, "%%\n$title\n$nuke_url/article.php?sid=$sid\n$time\n$aid\n$topictext\n".strip_tags($hometext)."\n$topicimage\n");
      fwrite($file2, "<NEWS>\n<NBX>$topictext</NBX>\n<TITLE>".stripslashes($title)."</TITLE>\n<SUMMARY>".strip_tags($hometext)."</SUMMARY>\n<URL>$nuke_url/article.php?sid=$sid</URL>\n<AUTHOR>".$aid."</AUTHOR>\n</NEWS>\n\n");
   }
   fclose($file);
}

function counter() {
   mysql_query("UPDATE vars SET value=value+1 where name='totalhits'");
}

function lnlbox() {
   $title = translate("NewsLetter");
   $boxstuff .= "<form action=lnl.php method=put><center>";
   $boxstuff .= "<select name=op><option value=subscribe>".translate("Subscribe")."</option>";
   $boxstuff .= "<option value=unsubscribe>".translate("Unsubscribe")."</option></select><br>";
   $boxstuff .= "<font size=1><b>".translate("Your email")."</b><br>";
   $boxstuff .= "<input type=text name=email size=12 maxlength=60><br>".translate("Register, it's Free !");
   $boxstuff .= "</center></form>";
   themesidebox($title, $boxstuff);
}

function topdownload() {
   $title = translate("most downloaded files");
   $boxstuff = topdownload_data(1,"short","dcounter");
   themesidebox($title, $boxstuff);
}

function lastdownload() {
   $title = translate("last downloadable files");
   $boxstuff = topdownload_data(1,"short","ddate");
   themesidebox($title, $boxstuff);
}

function topdownload_data($font, $form, $ordre) {
   global $top, $site_font, $language;
   $result = mysql_query("select did, dcounter, dfilename, dcategory, ddate, privs from downloads order by $ordre DESC limit 0,$top");
   $lugar=1;
   while(list($did, $dcounter, $dfilename, $dcategory, $ddate, $dperm) = mysql_fetch_row($result)) {
      if($dcounter>0) {
         $okfile=false;
         switch($dperm) {
           case "1":
              if (secur_static("member")) {$okfile=true;}
              break;
           case "2":
              if (secur_static("admin")) {$okfile=true;}
              break;

           default:
              $okfile=true;
              break;
         }
         if ($ordre=="dcounter") {
            $dd="( $dcounter )";
         }
         if ($ordre=="ddate") {
            if ($language!="english") {
               $dd="( ".substr($ddate,8,2)."-".substr($ddate,5,3).substr($ddate,0,4)." )";
            } else {
               $dd="( $ddate )";
            }
         }
         if ($form=="short") {
            if ($okfile)
               $ibid.="<font face=\"$site_font\" size=$font><li>$lugar: <a href=\"download.php?op=geninfo&did=$did\" title=\"$dd\" alt=\"$dd\">$dfilename</a></li></font>";
         } else {
            if ($okfile)
               $ibid.="<font face=\"$site_font\" size=$font><li>$lugar: <a href=\"download.php?op=geninfo&did=$did\">$dfilename</a> (".translate("Category"). " : $dcategory) - ($dcounter ".translate("downloads").")</li></font>";
         }
         if ($okfile)
            $lugar++;
      }
   }
   mysql_free_result($result);
   return $ibid;
}

function cookiedecode($user) {
   global $cookie;
   $userX = base64_decode($user);
   $cookie = explode(":", $userX);
   $result = mysql_query("select pass from users where uname='$cookie[1]'");
   list($pass) = mysql_fetch_row($result);
   if (($cookie[2] == md5($pass)) AND ($pass != "")) {
       return $cookie;
   } else {
       unset($user);
       unset($cookie);
   }
}

function getusrinfo($user) {
   $user2 = base64_decode($user);
   $user3 = explode(":", $user2);
   $result = mysql_query("select pass FROM users WHERE uname='$user3[1]'");
   list($pass) = mysql_fetch_row($result);
   $userinfos="";
   if (($user3[2] == md5($pass)) AND ($pass != "")) {
      $result = mysql_query("select uid, name, uname, email, femail, url, user_avatar, user_icq, user_occ, user_from, user_intrest, user_sig, user_viewemail, user_theme, user_aim, user_yim, user_msnm, pass, storynum, umode, uorder, thold, noscore, bio, ublockon, ublock, theme, commentmax, user_journal, send_email, is_visible FROM users WHERE uname='$user3[1]'");
      if (mysql_num_rows($result)==1) {
         $userinfo = mysql_fetch_array($result);
      } else {
         echo "<b>".translate("A problem ocurred").".</b><br>";
      }
   }
   return $userinfo;
}

function searchbox() {
   $title = "".translate("Search")."";
   $content = "<form action=\"search.php\" method=get>";
   $content .= "<br><center><input type=text name=query size=14></center>";
   $content .= "</form>";
   themesidebox($title, $content);
}

function FixQuotes ($what = "") {
   $what = ereg_replace("'","''",$what);
   while (eregi("\\\\'", $what)) {
      $what = ereg_replace("\\\\'","'",$what);
   }
   return $what;
}

function delQuotes($string){
   $tmp=""; $result=""; $i=0;
   $attrib=-1; # Are us in an HTML attrib ?   -1: no attrib   0: name of the attrib   1: value of the atrib
   $quote=0; # Is a string quote delimited opened ? 0=no, 1=yes
   $len = strlen($string);
   while ($i<$len) {
      switch($string[$i]) {
         case "\"":
              if ($quote==0) {
                 $quote=1;
              } else {
                 $quote=0;
                 if (($attrib>0) && ($tmp != "")) { $result .= "=\"$tmp\""; }
                    $tmp="";
                    $attrib=-1;
                 }
              break;
         case "=":
              if ($quote==0) {
                 $attrib=1;
                 if ($tmp!="") $result.=" $tmp";
                    $tmp="";
                 } else $tmp .= '=';
                    break;
         case " ":
              if ($attrib>0) {
                 $tmp .= $string[$i];
              }
         break;

         default:
              if ($attrib<0)
                 $attrib=0;
               $tmp .= $string[$i];
               break;
      }
      $i++;
   }
   if (($quote!=0) && ($tmp != "")) {
      if ($attrib==1) $result .= "=";
         $result .= "\"$tmp\"";
   }
   return $result;
}

function check_html ($str, $strip="") {
   global $AllowableHTML;
   if ($strip == "nohtml")
      $AllowableHTML=array('');
   $str = stripslashes($str);
   $str = eregi_replace("<[[:space:]]*([^>]*)[[:space:]]*>",'<\\1>', $str);
   // Delete all spaces from html tags .
   $str = eregi_replace("<a[^>]*href[[:space:]]*=[[:space:]]*\"?[[:space:]]*([^\" >]*)[[:space:]]*\"?[^>]*>",'<a href="\\1">', $str);
   // Delete all attribs from Anchor, except an href, double quoted.
   $str = eregi_replace("<img?",'', $str);
   $tmp = "";
   while (ereg("<(/?[[:alpha:]]*)[[:space:]]*([^>]*)>",$str,$reg)) {
      $i = strpos($str,$reg[0]);
      $l = strlen($reg[0]);
      if ($reg[1][0] == "/") $tag = strtolower(substr($reg[1],1));
      else $tag = strtolower($reg[1]);
      if ($a = $AllowableHTML[$tag])
         if ($reg[1][0] == "/") $tag = "</$tag>";
         elseif (($a == 1) || ($reg[2] == "")) $tag = "<$tag>";
         else {
            // Place here the double quote fix function.
            $attrb_list=delQuotes($reg[2]);
            $tag = "<$tag" . $attrb_list . ">";
         }
      else $tag = "";
      $tmp .= substr($str,0,$i) . $tag;
      $str = substr($str,$i+$l);
   }
   $str = $tmp . $str;
   return $str;
}

function check_words($Message) {
   global $CensorList, $CensorMode, $CensorReplace;
   $EditedMessage = $Message;
   if ($CensorMode != 0) {
      if (is_array($CensorList)) {
         $Replacement = $CensorReplace;

         if ($CensorMode == 1) { # Exact match
            $RegExPrefix   = '([^[:alpha:]]|^)';
            $RegExSuffix   = '([^[:alpha:]]|$)';
         } elseif ($CensorMode == 2) {    # Word beginning
            $RegExPrefix   = '([^[:alpha:]]|^)';
            $RegExSuffix   = '[[:alpha:]]*([^[:alpha:]]|$)';
         } elseif ($CensorMode == 3) {    # Word fragment
            $RegExPrefix   = '([^[:alpha:]]*)[[:alpha:]]*';
            $RegExSuffix   = '[[:alpha:]]*([^[:alpha:]]*)';
         }

         for ($i = 0; $i < count($CensorList) && $RegExPrefix != ''; $i++) {
            $EditedMessage = eregi_replace($RegExPrefix.$CensorList[$i].$RegExSuffix,"\\1$Replacement\\2",$EditedMessage);
         }
      }
   }
   return ($EditedMessage);
}

function filter_text($Message, $strip="") {
   $EditedMessage=check_html(check_words($Message), $strip);
   return ($EditedMessage);
}

function formatTimestamp($time) {
   global $datetime, $locale, $gmt;
   setlocale (LC_TIME, "$locale");
   ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $time, $datetime);
   $datetime = strftime("".translate("datestring")."", mktime($datetime[4]+$gmt,$datetime[5],$datetime[6],$datetime[2],$datetime[3],$datetime[1]));
   $datetime = ucfirst($datetime);
   return($datetime);
}

function formatAidHeader($aid) {
   $holder = mysql_query("SELECT url, email FROM authors where aid='$aid'");
   if ($holder) {
      list($url, $email) = mysql_fetch_row($holder);
      if (isset($url)) {
         echo "<a href=\"$url\">$aid</a>";
      } elseif (isset($email)) {
         echo "<a href=\"mailto:$email\">$aid</a>";
      } else {
         echo $aid;
      }
   }
}

// P.BR gestion + fine des destinataires des News via ihome (0,1, 2 -> 127, -127)
function ctrl_aff($ihome, $catid=0) {
   global $user;
   $affich=false;
   if ($ihome==0) {
      $affich=true;
   } elseif ($ihome==1) {
      if ($catid>0) {
         $affich=false;
      } else {
         $affich=true;
      }
   } elseif (($ihome>1) and ($ihome<=127)) {
      $tab_groupe=valid_group($user);
      for ($i=0; $i<=9; $i++) {
         if ($tab_groupe[$i]==$ihome) {
            $affich=true;
            break;
         }
      }
   } else {
      if ($user) $affich=true;
   }
   return ($affich);
}

function news_aff($type_req, $sel, $storynum, $oldnum) {
   global $user;
   // P.BR astuce pour affich le nb de News correct mme si certaines News ne sont pas visibles (membres, groupe de membres)
   // En fait on * le Nb de News par deux ou on affecte une valeur (big_story)
   if ($type_req=="index") {
      $Xstorynum=$storynum*2;
      $result = mysql_query("SELECT sid, catid, ihome FROM stories $sel order by sid DESC limit $Xstorynum");
      $Znum=$storynum;
   }
   if ($type_req=="old_news") {
      $Xstorynum=$oldnum*2;
      $result = mysql_query("select sid, catid, ihome FROM stories $sel order by time DESC limit $storynum, $Xstorynum");
      $Znum=$oldnum;
   }
   if (($type_req=="big_story") or ($type_req=="big_topic")) {
      if ($type_req=="big_topic") {
         $Xstorynum=$oldnum*2;
      } else {
         $Xstorynum=5;
      }
      $result = mysql_query("select sid, catid, ihome from stories $sel order by counter DESC limit $storynum, $Xstorynum");
      $Znum=$oldnum;
   }
   if ($type_req=="libre") {
      $Xstorynum=$oldnum*2;
      $result = mysql_query("SELECT sid, catid, ihome FROM stories $sel");
      $Znum=$oldnum;
   }
   if (!$result) {
      echo mysql_errno(). ": ".mysql_error(). "<br>"; exit();
   }
   $ibid=0;
   while (list($s_sid, $catid, $ihome) = mysql_fetch_row($result)) {
      if ($ibid==$Znum) {break;}
      if ($type_req=="libre") {$catid=0;}
      if (ctrl_aff($ihome, $catid)) {
         if (($type_req=="index") or ($type_req=="libre")) {
            $result2 = mysql_query("SELECT sid, catid, aid, title, time, hometext, bodytext, comments, counter, topic, informant, notes FROM stories where sid='$s_sid' and archive='0'");
         }
         if ($type_req=="old_news") {
            $result2 = mysql_query("select sid, title, time, comments from stories where sid='$s_sid' and archive='0'");
         }
         if (($type_req=="big_story") or ($type_req=="big_topic")) {
            $result2 = mysql_query("select sid, title from stories where sid='$s_sid' and archive='0'");
         }
         $tab[$ibid]=mysql_fetch_array($result2);
         if ($tab[$ibid]) {
            $ibid++;
         }
      }
   }
   mysql_free_result($result);
   return ($tab);
}

function bigstory() {
   global $cookie;
   $today = getdate();
   $day = $today["mday"];
   if ($day < 10)
      $day = "0$day";
   $month = $today["mon"];
   if ($month < 10)
      $month = "0$month";
   $year = $today["year"];
   $tdate = "$year-$month-$day";

   $xtab=news_aff("big_story","where (time LIKE '%$tdate%')",0,1);
   list($fsid, $ftitle) = $xtab[0];
   if ((!$fsid) AND (!$ftitle)) {
      $content = "<center>".translate("There isn't a Biggest Story for Today, yet.")."</center>";
   } else {
      $content = "<center>".translate("Today's most read Story is:")."<br><br>";
      if (isset($cookie[4])) { $options .= "&mode=$cookie[4]"; } else { $options .= "&mode=thread"; }
      if (isset($cookie[5])) { $options .= "&order=$cookie[5]"; } else { $options .= "&order=0"; }
      if (isset($cookie[6])) { $options .= "&thold=$cookie[6]"; } else { $options .= "&thold=0"; }
      $content .= "<a href=article.php?sid=$fsid$options>$ftitle</a></center>";
   }
   $boxtitle = "".translate("Today's Big<br>Story")."";
   themesidebox($boxtitle, $content);
}

function oldNews($storynum) {
   global $locale, $oldnum, $storyhome, $cookie, $categories, $cat, $user;
   $storynum = $storyhome;
   $boxstuff = "";
   $boxTitle = translate("Past Articles");

   if (isset($cookie[3])) {
      $storynum = $cookie[3];
   } else {
      $storynum = $storyhome;
   }
   if (($categories == 1) and ($cat != "")) {
      if ($user) { $sel = "WHERE catid='$cat'"; }
      else { $sel = "WHERE catid='$cat' AND ihome=0"; }
   } else {
      if ($user) { $sel = ""; }
      else { $sel = "WHERE ihome=0"; }
   }
   $vari = 0;
   if (isset($cookie[4])) {
      $options .= "&mode=$cookie[4]";
   } else {
      $options .= "&mode=thread";
   }
   if (isset($cookie[5])) {
      $options .= "&order=$cookie[5]";
   } else {
      $options .= "&order=0";
   }
   if (isset($cookie[6])) {
      $options .= "&thold=$cookie[6]";
   } else {
      $options .= "&thold=0";
   }
   $xtab=news_aff("old_news", $sel, $storynum, $oldnum);
   $story_limit=0;
   while (($story_limit<$oldnum) and ($story_limit<sizeof($xtab))) {
      list($sid, $title, $time, $comments) = $xtab[$story_limit];
      $story_limit++;
      setlocale (LC_TIME, "$locale");
      ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $time, $datetime2);
      $datetime2 = strftime("".translate("datestring2")."", mktime($datetime2[4],$datetime2[5],$datetime2[6],$datetime2[2],$datetime2[3],$datetime2[1]));
      $datetime2 = ucfirst($datetime2);
      if ($time2==$datetime2) {
         $boxstuff .= "<font size=1><li><a href=\"article.php?sid=$sid$options\">$title</a> ($comments)</font>\n";
      } else {
         if ($a=="") {
            $boxstuff .= "<font size=1><b>$datetime2</b><br><li><a href=\"article.php?sid=$sid$options\">$title</a> ($comments)</font>\n";
            $time2 = $datetime2;
            $a = 1;
         } else {
            $boxstuff .= "<br><br><font size=1><b>$datetime2</b><br><li><a href=\"article.php?sid=$sid$options\">$title</a> ($comments)</font>\n";
            $time2 = $datetime2;
         }
      }
      $vari++;
      if ($vari==$oldnum) {
         if (isset($cookie[3])) {
            $storynum = $cookie[3];
         } else {
            $storynum = $storyhome;
         }
         $min = $oldnum + $storynum;
         $boxstuff .= "<br><p align=center><font size=1><a href=\"search.php?min=$min&type=stories&category=$cat\"><b>".translate("Older Articles")."</b></a></font>\n";
      }
   }
   themesidebox($boxTitle, $boxstuff);
}

function themepreview($title, $hometext, $bodytext="", $notes="") {
   echo "<b>$title</b><br>$hometext<br>$bodytext<br>$notes";
}

function mainblock() {
   $result = mysql_query("select title, content from mainblock");
   list($title, $content) = mysql_fetch_array($result);
   themesidebox($title, nl2br($content));
}

function category() {
   global $cat, $language;
   $result = mysql_query("select catid, title from stories_cat order by title");
   $numrows = mysql_num_rows($result);
   if ($numrows == 0) {
      return;
   } else {
      while (list($catid, $title) = mysql_fetch_row($result)) {
         $result2 = mysql_query("select sid from stories where catid='$catid' limit 0,1");
         $numrows = mysql_num_rows($result2);
         if ($numrows > 0) {
            $res = mysql_query("select time from stories where catid='$catid' order by sid DESC limit 0,1");
            list($time) = mysql_fetch_row($res);
            ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $time, $dat);
            if ($cat == $catid) {
               $boxstuff .= "<li><b>$title</b>";
            } else {
               $boxstuff .= "<font size=2><li><a href=\"index.php?op=newindex&catid=$catid\">$title</a></font>";
               if ($language=="english") {
                  $boxstuff .= "<font size=1>($dat[2]/$dat[3])</font>";
               } else {
                  $boxstuff .= "<font size=1>($dat[3]/$dat[2])</font>";
               }
            }
         }
      }
      $title = "Categories";
      themesidebox($title, $boxstuff);
   }
}

function valid_group($xuser) {
   $userdata = explode(":",base64_decode($xuser));
   $user_temp=mysql_query("select groupe from users_status where uid='$userdata[0]'");
   list($groupe) = mysql_fetch_row($user_temp);
   $tab_groupe=explode(",",$groupe);
   return ($tab_groupe);
}

function block_fonction($contentX) {
   // P.BR for including PHP functions in block
   if (stristr($contentX,"function#")) {
      $contentX=str_replace("<br />","",$contentX);
      $contentX=str_replace("<br>","",$contentX);
      $contentY=trim(substr($contentX,9));
      if (stristr($contentY,"params#")) {
         $pos = strpos($contentY,"params#");
         $contentII=trim(substr($contentY,0,$pos));
         $params=substr($contentY,$pos+7);
         $prm=explode(",",$params);
         // P.BR remplace le param "False" par la valeur false (idem pour True)
         for ($i=0; $i<=count($prm)-1; $i++) {
            if ($prm[$i]=="false") {$prm[$i]=false;}
            if ($prm[$i]=="true") {$prm[$i]=true;}
         }
         // P.BR en fonction du nombre de params de la fonction : limite actuelle : 8
         if (function_exists($contentII)) {
            switch(count($prm)) {
               case 1:
                  $contentII($prm[0]); break;
               case 2:
                  $contentII($prm[0],$prm[1]); break;
               case 3:
                  $contentII($prm[0],$prm[1],$prm[2]); break;
               case 4:
                  $contentII($prm[0],$prm[1],$prm[2],$prm[3]); break;
               case 5:
                  $contentII($prm[0],$prm[1],$prm[2],$prm[3],$prm[4]); break;
               case 6:
                  $contentII($prm[0],$prm[1],$prm[2],$prm[3],$prm[4],$prm[5]); break;
               case 7:
                  $contentII($prm[0],$prm[1],$prm[2],$prm[3],$prm[4],$prm[5],$prm[6]); break;
               case 8:
                  $contentII($prm[0],$prm[1],$prm[2],$prm[3],$prm[4],$prm[5],$prm[6],$prm[7]); break;
            }
            return (true);
         } else {
            return (false);
         }
      } else {
         if (function_exists($contentY)) {
            $contentY();
            return (true);
         } else {
            return (false);
         }
      }
   } else {
      return (false);
   }
}

function fab_block($title, $member, $content, $Xcache) {
   global $SuperCache, $CACHE_TIMINGS;
   if (($SuperCache) and ($Xcache!=0)) {
      $CACHE_TIMINGS[$title]=$Xcache;
      $cache_obj = new cacheManager();
      $cache_obj->startCachingBlock($title);
   }
   if (($cache_obj->genereting_output==1) or ($cache_obj->genereting_output==-1) or (!$SuperCache) or ($Xcache==0)) {
      global $user;
      // P.BR for Javascript in Block
      if (!stristr($content,"javascript")) {
         $content = nl2br($content);
      }
      // P.BR for including externale file in block / the return MUST BE in $content
      if (stristr($content,"include#")) {
         $Xcontent=false;
         // You can now, include AND cast a fonction with params in the same bloc !
         if (stristr($content,"function#")) {
            $content=str_replace("<br />","",$content);
            $content=str_replace("<br>","",$content);
            $pos = strpos($content,"function#");
            $Xcontent=substr(trim($content),$pos);
            $content=substr(trim($content),8,$pos-10);
         } else {
            $content=substr(trim($content),8);
         }
         include($content);
         if ($Xcontent) {$content=$Xcontent;}
      }

      if (!empty($content)) {
         // P.BR for member's only blocks
         if (($member==1) and (isset($user))) {
            if (!block_fonction($content)) {
               themesidebox($title, $content);
            }
         } elseif ($member==0) {
            if (!block_fonction($content)) {
               themesidebox($title, $content);
            }
         } elseif (($member>1) and (isset($user))) {
            $tab_groupe=valid_group($user);
            for ($i=0; $i<=9; $i++) {
               if ($tab_groupe[$i]==$member) {
                  if (!block_fonction($content)) {
                     themesidebox($title, $content);
                  }
                  break;
               }
            }
         }
      }
      if (($SuperCache) and ($Xcache!=0))
         $cache_obj->endCachingBlock($title);
   }
}

function rightblocks() {
   Pre_fab_block("","RB");
}
function leftblocks() {
   Pre_fab_block("","LB");
}
function oneblock($Xid, $Xblock) {
   Pre_fab_block($Xid, $Xblock);
}
function Pre_fab_block($Xid, $Xblock) {
   if ($Xid) {
      if ($Xblock=="RB") {
         $result = mysql_query("select title, content, member, cache, actif from rblocks where id='$Xid'");
      } else {
         $result = mysql_query("select title, content, member, cache, actif from lblocks where id='$Xid'");
      }
   } else {
      if ($Xblock=="RB") {
         $result = mysql_query("select title, content, member, cache, actif from rblocks order by Rindex ASC");
      } else {
         $result = mysql_query("select title, content, member, cache, actif from lblocks order by Lindex ASC");
      }
   }
   while (list($title, $content, $member, $cache, $actif) = mysql_fetch_array($result)) {
      if (($actif) or ($Xid))
         fab_block($title, $member, $content, $cache);
   }
   mysql_free_result($result);
}

function adminblock() {
   global $admin;
   if ($admin) {
       $result = mysql_query("select title, content from adminblock");
       while (list($title, $content) = mysql_fetch_array($result)) {
          $content = "<font size=1>".nl2br($content)."</font>";
          themesidebox($title, $content);
       }
       $title = "".translate("Waiting Content")."";
       $result = mysql_query("select * from queue");
       $num = mysql_num_rows($result);
       $content = "<li><font size=1><a href=\"admin.php?op=submissions\">".translate("Submissions")."</a> : $num</font>";
       $result = mysql_query("select * from reviews_add");
       $num = mysql_num_rows($result);
       $content .= "<li><font size=1><a href=\"admin.php?op=reviews\">".translate("Waiting Reviews")."</a> : $num</font>";
       $result = mysql_query("select * from links_modrequest where brokenlink=1");
       $totalbrokenlinks = mysql_num_rows($result);
       $result2 = mysql_query("select * from links_modrequest where brokenlink=0");
       $totalmodrequests = mysql_num_rows($result2);
       $result = mysql_query("select * from links_newlink");
       $num = mysql_num_rows($result);
       $content .= "<li><font size=1><a href=\"admin.php?op=links\">".translate("Waiting Links")."</a> : $num / $totalbrokenlinks / $totalmodrequests</font>";
       $result = mysql_query("select * from sdv where status='stb'");
       $num = mysql_num_rows($result);
       $content .= "<li><font size=1><a href=\"admin.php?op=sdv\">".translate("Waiting Classifieds")."</a> : $num</font>";
       themesidebox($title, $content);
    }
}

function ephemblock() {
   global $Ephemerids, $gmt;
   if ($Ephemerids == 1) {
       $eday=date("d",time()+($gmt*3600));
       $emonth =date("m",time()+($gmt*3600));
       $result = mysql_query("select yid, content from ephem where did='$eday' AND mid='$emonth'");
       $title = "".translate("Ephemerids")."";
       $boxstuff = "<center><b>".translate("One Day like Today...")."</b></center><br>";
       while(list($yid, $content) = mysql_fetch_array($result)) {
           if ($cnt==1)
              $boxstuff .= "<br><br>";
           $boxstuff .= "<b>$yid</b><br>";
           $boxstuff .= "$content";
           $cnt = 1;
       }
       themesidebox($title, $boxstuff);
   }
}

function loginbox() {
   global $user;
   if (!$user) {
      $title = "$sitename Login";
      $boxstuff .= "<form action=user.php method=post>";
      $boxstuff .= "<font size=1><center>".translate("Nickname")."<br>";
      $boxstuff .= "<input type=text name=uname size=12 maxlength=25><br>";
      $boxstuff .= "".translate("Password")."<br>";
      $boxstuff .= "<input type=password name=pass size=12 maxlength=20><br>";
      $boxstuff .= "<input type=hidden name=op value=login>";
      $boxstuff .= "<input type=submit value=".translate("Login")."></form>";
      $boxstuff .= "".translate("Don't have an account yet? You can")."";
      $boxstuff .= " <a href=user.php>".translate("create one")."</a>.";
      $boxstuff .= " ".translate("As registered")."";
      $boxstuff .= " ".translate("user you have some advantages like theme manager,")."";
      $boxstuff .= " ".translate("comments configuration and post comments with your name.")."";
      $boxstuff .= "</center>";
      themesidebox($title, $boxstuff);
   }
}

function userblock() {
   global $user, $cookie;
   if (($user) AND ($cookie[8])) {
      $getblock = mysql_query("select ublock from users where uid='$cookie[0]'");
      $title = "".translate("Menu for")." $cookie[1]";
      list($ublock) = mysql_fetch_row($getblock);
      themesidebox($title, $ublock);
   }
}

function getTopics($s_sid) {
   global $topicname, $topicimage, $topictext;
   $sid = $s_sid;
   $result=mysql_query("SELECT topic FROM stories where sid=$sid");
   if ($result) {
      list($topic) = mysql_fetch_row($result);
      $result=mysql_query("SELECT topicid, topicname, topicimage, topictext FROM topics where topicid=$topic");
      if ($result) {
         list($topicid, $topicname, $topicimage, $topictext) = mysql_fetch_row($result);
         return (true);
      } else {
         return (false);
      }
   } else {
      return (false);
   }
}

function headlines() {
  global $Version_Num, $Version_Id, $system, $rss_host_verif;

  // P.BR Proxy
  if (file_exists("proxy.conf.php")) {
     include("proxy.conf.php");
  }
  // Security Patch
  $result = mysql_query("select sitename, url, headlinesurl, hid from headlines where status=1");
  while (list($sitename, $url, $headlinesurl, $hid) = mysql_fetch_row($result)) {
    $boxtitle     =         "$sitename";
    $separ        =        "<li>";
    $cache_file   =        "cache/$sitename.cache";
    $cache_time   =        3600;
    $max_items    =        10;
    $target       =        "new";
    $items        =        0;
    $time         =        split(" ", microtime());
    $rss_timeout  =        15;
    $rss_font     =        "<font size=1>";
    srand((double)microtime()*1000000);
    $cache_time_rnd = 300 - rand(0, $cache_time);

    if ( (!(file_exists($cache_file))) || ((filectime($cache_file) + $cache_time - $time[1]) + $cache_time_rnd < 0) || (!(filesize($cache_file))) ) {
       // Security Patch
       $rss=parse_url($url);
       if ($rss_host_verif==true) {
          $verif = fsockopen($rss['host'], 80, $errno, $errstr, $rss_timeout);
          if ($verif) {
             fclose($verif);
             $verif=true;
          }
       } else {
          $verif=true;
       }

       if (!$verif) {
          $cache_file_sec=$cache_file.".security";
          if (file_exists($cache_file)) {
             $ibid=rename($cache_file, $cache_file_sec);
          }
          themesidebox($boxtitle, "Security Error");
          return;
       } else {
        // P.BR Proxy
        if (isset($proxy_url[$hid])) {
           $fpread=fsockopen($proxy_url[$hid],$proxy_port[$hid],$errno,$errstr,$rss_timeout);
           fputs($fpread,"GET $headlinesurl/ HTTP/1.0\n\n");
        } else {
           $fpread = fopen($headlinesurl, 'r');
        }
        if ($fpread) {
           $fpwrite = fopen($cache_file, 'w');
           if ($fpwrite) {
              while(!feof($fpread)) {
                 $buffer = ltrim(Chop(fgets($fpread, 512)));
                 if (($buffer == "<item>") && ($items < $max_items)) {
                    $title = ltrim(Chop(fgets($fpread, 256)));
                    $link = ltrim(Chop(fgets($fpread, 256)));
                    $title = ereg_replace( "<title>", "", $title );
                    $title = ereg_replace( "</title>", "", $title );
                    $title = ereg_replace( "\"", "\\\"", $title );
                    $link = ereg_replace( "<link>", "", $link );
                    $link = ereg_replace( "</link>", "", $link );
                    fputs($fpwrite, "$separ<A HREF=$link TARGET=$target>$title</A><BR>\n");
                    $items++;
                 }
              }
              fclose($fpwrite);
           }
           fclose($fpread);
        }
       }
    }
    if (file_exists($cache_file)) {
       // Security Patch
        ob_start();
        $ibid=readfile($cache_file);
        $boxstuff=$rss_font.ob_get_contents()."</font>";
        ob_end_clean();
       // end Security Patch
    }
    $boxstuff .= "<br><DIV align=right><a href=\"$url\" target=blank><b>".translate("read more...")."</b></a></DIV>";
    themesidebox($boxtitle, $boxstuff);
    $boxstuff = "";
  }
}

function subscribe_mail($Xtype, $Xtopic,$Xforum, $Xresume, $Xsauf) {
   // $Xtype : topic, forum ... / $Xtopic clause where / $Xforum id of forum / $Xresume Text passed / $Xsauf not this userid
   global $sitename;
   global $nuke_url;
   if ($Xtype=="topic") {
      $result=mysql_query("select topictext from topics where topicid='$Xtopic'");
      list($abo)=mysql_fetch_row($result);
      $result=mysql_query("select uid from subscribe where topicid='$Xtopic'");
      $entete=translate("You are receiving this email in accordance to your subscription :").translate("Topic")." => $abo\n\n";
      $resume=translate("The title of the last new post is")." => $Xresume\n\n";
      $url=translate("The URL for this story is:")."$nuke_url/search.php?query=&topic=$Xtopic\n\n";
   }
   if ($Xtype=="forum") {
      $result=mysql_query("select forum_name from forums where forum_id='$Xforum'");
      list($abo)=mysql_fetch_row($result);
      $result=mysql_query("select uid from subscribe where forumid='$Xforum'");
      $entete=translate("You are receiving this email in accordance to your subscription :")."Forum => $abo\n\n";
      $url=translate("The URL for this story is:")."$nuke_url/viewtopic.php?topic=$Xtopic&forum=$Xforum\n\n";
      if ($Xresume!="") {
         $resume=translate("The title of the last new post is")." => $Xresume\n\n";
      } else {
         $resume=translate("A new post was send in this Forum.")."\n\n";
      }
   }
   $subject = translate("Subscribe")." / $sitename";
   $message = $entete;
   $message .= "".$resume;
   $message .= "".$url;
   include("signat.php");

   while(list($uid) = mysql_fetch_array($result)) {
      if ($uid!=$Xsauf) {
         $resultX=mysql_query("select email from users where uid='$uid'");
         list($email)=mysql_fetch_row($resultX);
         send_email($email, $subject, $message, "", true, "text");
      }
   }
}

function subscribe_query($Xuser,$Xtype, $Xclef) {
   if ($Xtype=="topic") {
      $result=mysql_query("select topicid from subscribe where uid='$Xuser' and topicid='$Xclef'");
   }
   if ($Xtype=="forum") {
      $result=mysql_query("select forumid from subscribe where uid='$Xuser' and forumid='$Xclef'");
   }
   list($Xtemp) = mysql_fetch_array($result);
   if ($Xtemp!="") {
      return (true);
   } else {
      return (false);
   }
}

// Poll Fonctions
function pollMain($pollID) {
   global $maxOptions, $boxTitle, $boxContent, $uimages, $pollcomm, $cookie;
   if (!isset($pollID))
      $pollID = 1;
   if (!isset($url))
      $url = sprintf("pollBooth.php?op=results&pollID=%d", $pollID);
   $boxContent .= "<form action=\"pollBooth.php\" method=\"post\">";
   $boxContent .= "<input type=\"hidden\" name=\"pollID\" value=\"".$pollID."\">";
   $boxContent .= "<input type=\"hidden\" name=\"forwarder\" value=\"".$url."\">";
   $result = mysql_query("SELECT pollTitle, voters FROM poll_desc WHERE pollID=$pollID");
   list($pollTitle, $voters) = mysql_fetch_row($result);
   $boxTitle = translate("Survey");
   $boxContent .= "<font size=2><b>$pollTitle</b></font><br><br>\n";
   for ($i = 1; $i <= $maxOptions; $i++) {
      $result = mysql_query("SELECT pollID, optionText, optionCount, voteID FROM poll_data WHERE (pollID=$pollID) AND (voteID=$i)");
      $object = mysql_fetch_object($result);
      if (is_object($object)) {
         $optionText = $object->optionText;
         if ($optionText != "") {
            $boxContent .= "<input type=\"radio\" name=\"voteID\" value=\"".$i."\"> $optionText <br>\n";
         }
      }
   }
   $boxContent .= "<br><center><table cellspacing=0 cellpadding=5 border=0 width=111><tr><td align=center><input type=image src=$uimages/vote.gif border=0></td><td align=center>\n";
   $result = mysql_query("SELECT SUM(optionCount) AS SUM FROM poll_data WHERE pollID=$pollID");
   $sum = (int)mysql_result($result, 0, "SUM");

   $boxContent .= "<a href=\"pollBooth.php?op=results&pollID=$pollID&mode=$cookie[4]&order=$cookie[5]&thold=$cookie[6]\"><img src=$uimages/result.gif border=0></a></td></tr></table>
   <font size=1><b><a href=\"pollBooth.php\">".translate("Past Surveys")."</a></b></font><br>";
   if ($pollcomm) {
      list($numcom) = mysql_fetch_row(mysql_query("select count(*) from pollcomments where pollID=$pollID"));
      $boxContent .= "<br><font size=1>".translate("Votes: ")."<b>$sum</b><br>".translate("comments:")."  <b>$numcom</b></font>\n";
   } else {
      $boxContent .= "<br><font size=1>".translate("Votes: ")."<b>$sum</b></font>\n";
   }
   $boxContent .= "</form></center>\n\n";
   themesidebox($boxTitle, $boxContent);
}

function PollNewest() {
   global $poll;
   if ($poll) {
      if ($result = mysql_query("SELECT pollID FROM poll_data order BY pollID Desc limit 1")) {
         list($pollID)=mysql_fetch_row($result);
         if ($ibid=pollSecur($pollID)) {pollMain($ibid);}
      }
   }
}

function pollSecur($pollID) {
   global $user;
   $pollIDX=false;
   $result = mysql_query("SELECT pollType FROM poll_data where pollID='$pollID'");
   if (mysql_numrows($result)) {
      list($pollType)=mysql_fetch_row($result);
      if ((($pollType) and (isset($user))) or (!$pollType)) {
         $pollIDX=$pollID;
      }
   }
   return ($pollIDX);
}
?>